#include<stdio.h>
#include<vector>
#include<stdint.h>
#include <algorithm>
#include<iostream>

struct record //record
{/* data */
    unsigned long int d1; //dan
    unsigned long int p1; //broj pakovanja
};
bool cmper(const record &a, const record &b){
    return a.d1 < b.d1;
}
int main(int argc, char const *argv[])
{
    unsigned long int N; //ukupan broj puta s pronalaskom
    unsigned long int k;
    unsigned long int Q; //ukupan broj pitanja
    unsigned long int d; //za dan
    unsigned long int p; //za broj plazme kupljen tog dana

    std::vector<record> Zapisnik;
    std::vector<unsigned long int> f;
    record temp; // privremeni record za zapisivanje
    printf("Koliko je dana Otac trazio plazmu? >");
    scanf("%ld", &N);
    printf("Koliko pitanja postavljamo? >");
    scanf("%ld", &Q);
    if(((N==0)||(Q==0))||((N > 300000)||(Q > 300000))){printf("nedozvoljena vrednost!!"); return 0;}
    printf("uneti Informacije o kupovini plazme: (dan, broj plazme)\n");
    while(N > 0) { //Upisivanje:
        scanf("%ld %ld", &d, &p);
        if((d==0)||(p==0)){printf("nedozvoljena vrednost!!"); return 0;}
        if(d>1000000000000000000){printf("nedozvoljena vrednost!!"); return 0;}
        if(p>1000000000){printf("nedozvoljena vrednost!!"); return 0;}
        for(unsigned long int &D : f){if(D==d){printf("uneli ste isti dan dvaput!"); return 0;}}
        f.push_back(d);
        temp.d1 = d; temp.p1 = p;
        Zapisnik.push_back(temp);
        N--;
    }
    // unosenje Q:
    f.clear();
    k = 0;
    printf("uneti dane kada je kcer prestala da jede plazmu: \n");
    while(Q > 0){
        scanf("%ld", &k);
        if((k>1000000000000000000)||(k==0)){printf("nedozvoljena vrednost!!"); return 0;}
        f.push_back(k);
        Q--;
    }
    //Sort Zapisnik:
    std::sort(Zapisnik.begin(), Zapisnik.end(), cmper);
    //Resavanje ;]
    printf("Resavanje: \n");
    k = 0; d = Zapisnik[0].d1;
    for(unsigned long int &kf: f){
        if(kf >  3000000013){kf = 3000000013;}
        if(kf <= d){printf("0\n");}
        else{
            k = kf;
            k -= d;
            k--;
            printf("%ld \n", k);
        }
    }
}